/*

 ideserv - An incomplete and buggy PCLink server for IDEDOS 0.9x

 Written by
  Kajtar Zsolt <soci@c64.rulez.org>

    This file is part of IDEDOS the IDE64 disk operating system
    See README for copyright notice.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <sys/io.h>
#include <fcntl.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <pwd.h>
#include <grp.h>
#include <err.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <argp.h>
#include <sys/resource.h>
#include <stdlib.h>
FILE *lf;
#include "ideserv.h"
#include "crc8.h"

#define CM_CLOSED 0
#define CM_FILE 1
#define CM_DIR 2
#define CM_ERR 3

#define OPEN_RONLY 0
#define OPEN_STATUS 2
#define OPEN_WONLY 4
#define OPEN_ERR 6

const char *argp_program_version="ideservd 0.16";
FILE *files[16];
int channelmode[16];
unsigned char buffer[16][65536];
unsigned short int buffbytes[16];
unsigned short int buffp[16];

void seterror(char *s) {
    strcpy(buffer[15],s);
    buffbytes[15]=strlen(buffer[15]);
    buffp[15]=0;
}

void errtochannel15(int i) {
    if (i)
        switch (errno) {
        case EISDIR:
        case ENOTDIR:
        case ENOENT:seterror("62, FILE NOT FOUND,000,000,000,000\r");break;
        case EEXIST:seterror("63, FILE EXISTS,000,000,000,000\r");break;
        case EPERM:
        case EACCES:seterror("27, ACCESS DENIED,000,000,000,000\r");break;
        case ENOTEMPTY:seterror("01, FILES SCRATCHED,000,000,000,000\r");break;
        case ENOSPC:seterror("72, PARTITION FULL,000,000,000,000\r");break;
        case EROFS:seterror("26, WRITE PROTECT ON,000,000,000,000\r");break;
        case EIO:seterror("23, READ ERROR,000,000,000,000\r");break;
        default:fprintf(lf,"=%d=",errno);seterror("80, ERROR,000,000,000,000\r");
        }
    else seterror("00, OK,000,000,000,000\r");
}

void convertfilename(char *s, char typek, char *vessz, char *overwrite, char *name, char *mode) {
    int b,i,j,kpontv;

    i=j=*vessz=*overwrite=*mode=0;

    kpontv=0;
    for (b=0;s[b];b++) if (s[b]==':') {
        kpontv=1;
        if (s[0]=='@') *overwrite=1;
        break;
    }

    for (b=0;s[b];b++) {
        s[b]=c64toascii[(unsigned char)s[b]];
        if (s[b]==':') {i=*vessz=j=*mode=0; continue;}

        switch (*vessz) {
        case 0:
            if (s[b]==typek) {
                (*vessz)++;
                name[i]=',';
            } else name[i]=s[b];
            j++;
            i++;
            break;
        case 1:
            if (s[b]==',') {
                (*vessz)++;
                break;
            }
            name[i]=s[b];
            i++;
            break;
        case 2:if (mode) *mode=s[b];(*vessz)++;break;
        }
    }
    name[i]=0;
    if (i==(j+1)) switch (name[i-1]) {
        case 's':strcat(name,"eq");break;
        case 'p':strcat(name,"rg");break;
        case 'u':strcat(name,"sr");break;
    }
}

void commandchannel(char *s) {
    unsigned char b;
	if (!strncmp(s,"CD:",3) || !strncmp(s,"CD/",3)) {
	    for (b=0;s[b];b++) s[b]=c64toascii[(unsigned char)s[b]];
            errtochannel15(chdir(&s[3]));
	    fprintf(lf,"Chdir \"%s\"\n",&s[3]);
	} else if (!strncmp(s,"MD:",3)) {
	    for (b=0;s[b];b++) s[b]=c64toascii[(unsigned char)s[b]];
            errtochannel15(mkdir(&s[3],0777));
	    fprintf(lf,"Mkdir \"%s\"\n",&s[3]);
	} else if (!strncmp(s,"RD:",3)) {
	    for (b=0;s[b];b++) s[b]=c64toascii[(unsigned char)s[b]];
            errtochannel15(rmdir(&s[3]));
	    fprintf(lf,"Rmdir \"%s\"\n",&s[3]);
        } else if (!strncmp(s,"S:",2)) {
            unsigned char vessz,o;
            int r;
            convertfilename(s,'=',&vessz,&o,s,&o);
            r=unlink(s);
            if (r) {
                if (vessz==0) strcat(s,",");
                r=unlink(s);
            }
            if (r) {
                if (vessz==0) strcat(s,"prg");
                r=unlink(s);
            }
            errtochannel15(r);
	    fprintf(lf,"Rm \"%s\"\n",s);
	} else if (!strncmp(s,"CD_",3)) {
	    errtochannel15(chdir(".."));
	    fprintf(lf,"Chdir \"..\"\n");
        } else if (!strncmp(s,"C\xd0",2)) {
            seterror("02, PARTITION SELECTED,001,000,000,000\r");
            fprintf(lf,"Change to partition %d\n",s[3]);
        } else if (!strncmp(s,"UI",2)) {
	    seterror("73, IDESERV 0.16 PCLINK,000,000,000,000\r");
	    fprintf(lf,"Identify device\n");
	} else if (!strncmp(s,"I",1)) {
	    errtochannel15(chdir("/"));
	    fprintf(lf,"Initialize\n");
	} else if (s[0]) {
	    seterror("31, UNKNOWN COMMAND,000,000,000,000\r");
	} else fprintf(lf,"\n");
}

void openfile(int usecrc) {
    unsigned char s[256];
    unsigned char status=OPEN_ERR;
    unsigned char channel,ch,fp;
    unsigned long long l=0;

    ch=getb();if (tout) return;
    channel=ch & 0x0f;

    fp=0;
    while (fp<255) {
        s[fp]=getb();if (tout) return;
        if (!s[fp]) break;
        fp++;
    }
    s[fp]=0;

    if (usecrc) {
        unsigned char crc=crc8[0xCF],gcrc,gt;
        crc=crc8[crc ^ ch];
        fp=0;
        while (s[fp]) { crc=crc8[crc ^ s[fp]]; fp++;}
	crc=crc8[crc];
        gcrc=getb();if (tout) return;
        crc=crc8[crc ^ gcrc];
        gt=getb();if (tout) return;
        if (crc) {
            fprintf(lf,"CRC error %02X: CF %02X ",crc,ch);
            fp=0;
            while (s[fp]) {fprintf(lf,"%02X ",s[fp]);fp++;}
            fprintf(lf,"00 %02X %02X\n",gcrc,gt);
            return;
        }
    }
    alarm(0);

    if (channel==15) {
	channelmode[15]=CM_ERR;
        fprintf(lf,"Open [%d]: \"%s\": ",channel,s);
	commandchannel(s);
	status=OPEN_STATUS;
    } else {
        unsigned char mode,overwrite,vessz;
        convertfilename(s,',',&vessz,&overwrite,s,&mode);
        fprintf(lf,"Open [%d]: \"%s\": ",channel,s);
        
        if (channelmode[channel]==CM_FILE) fclose(files[channel]);
        channelmode[channel]=CM_CLOSED;

        if (s[0]=='$') {
            unsigned char dirline[32];
            struct dirent *ep;
            DIR *dp;
            int sum=0;
            channelmode[channel]=CM_DIR;
            buffbytes[channel]=buffp[channel]=0;

            if (!strncmp(&s[1],"=p",2)) {
                memcpy(&dirline[0x00],"\1\4\1\1\377\0\22\42",8);
                memset(&dirline[0x08],32,16);
                memcpy(&dirline[0x18],"\42\40LINUX\0",8);
                for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
                dirline[0x00]=dirline[0x01]=1;
                dirline[0x02]=1;
                dirline[0x03]=0;
                memcpy(&dirline[0x04],"   \42PARTITION 1\42      NET  \0",28);
                for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
                dirline[0x00]=dirline[0x01]=1;
                dirline[0x02]=1;
                dirline[0x03]=0;
                memcpy(&dirline[0x04],"PARTITIONS.              \0\0\0",28);
                for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
                status=OPEN_RONLY;
            } else {

                if (!s[1]) {s[1]='.';s[2]=0;}
                dp=opendir(&s[1]);
                if (!dp) {sendb(2);errtochannel15(1);fprintf(lf,"Couldn't open the directory.\n");return;}
//                sendb(OPEN_RONLY);
                memcpy(&dirline[0x00],"\1\4\1\1\1\0\22\42",8);
                memset(&dirline[0x08],32,16);
                memcpy(&dirline[0x18],"\42\40LINUX\0",8);
                for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];

                while ((ep=readdir(dp)))
                {
                    struct stat buf;
                    int offs,n;
                    char *p,i[1000];
                    strncpy(i,&s[1],999);
                    strncat(i,"/",999);
                    strncat(i,ep->d_name,999);
                    if (lstat(i,&buf)) break;

                    //                fprintf(lf,"%s %d ",&i,buf.st_size);
                    buf.st_size=(buf.st_size+255)>>8;
                    if (buf.st_size>65535) buf.st_size=65535;

                    dirline[0x00]=dirline[0x01]=1;
                    dirline[0x02]=buf.st_size & 0xff;
                    dirline[0x03]=buf.st_size>>8 & 0xff;
                    memset(&dirline[0x04],32,27);
                    offs=7;
                    if (buf.st_size>9) offs--;
                    if (buf.st_size>99) offs--;
                    if (buf.st_size>999) offs--;
                    dirline[offs++]=0x22;
                    n=0;while (ep->d_name[n] && ep->d_name[n]!=',' && n<16) dirline[offs++]=topetscii[(unsigned char)ep->d_name[n++]];
                    dirline[offs++]=0x22;
                    offs+=(16-n);

                    dirline[offs++]=0x20;
                    if (S_ISDIR(buf.st_mode)) p="dir";
                    else if (S_ISREG(buf.st_mode)) {
                        p=&ep->d_name[n+1];
                        if (ep->d_name[n]!=',') {if (buf.st_mode & S_IXUSR) p="prg"; else p="";}
                    }
                    else if (S_ISLNK(buf.st_mode)) p="lnk";
                    else p="";

                    n=0;while (p[n] && n<3) dirline[offs++]=topetscii[(unsigned char)p[n++]];
                    dirline[offs]=access(i,W_OK)?'<':' ';

                    for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
                    sum+=buf.st_size;
                    if (sum>65535) sum=65535;
                }

                dirline[0x00]=dirline[0x01]=1;
                dirline[0x02]=sum & 0xff;
                dirline[0x03]=sum>>8 & 0xff;
                memcpy(&dirline[0x04],"BLOCKS USED.             \0\0\0",28);

                for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
                errtochannel15(closedir(dp));
                status=OPEN_RONLY;
            }
        } else {
            switch (channel) {
            case 0:
                {
                    files[channel]=fopen(s,"rb");
                    if (!files[channel] && vessz==0) {
                        strcat(s,",");
                        files[channel]=fopen(s,"rb");
                    }
                    if (!files[channel] && vessz==0) {
                        strcat(s,"prg");
                        files[channel]=fopen(s,"rb");
                    }
                    if (files[channel]) {
                        status=OPEN_RONLY;
                        channelmode[channel]=CM_FILE;
                        errtochannel15(0);
                    } else errtochannel15(1);
                    break;
                }
            case 1:
                {
                    int f;

                    if (vessz==0) strcat(s,",prg");

                    if (overwrite) f=open(s, O_CREAT|O_WRONLY, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
                    else f=open(s, O_CREAT|O_EXCL|O_WRONLY, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);

                    if (f<0) errtochannel15(1); else {
                        status=OPEN_WONLY;
                        files[channel]=fdopen(f,"wb");
                        channelmode[channel]=CM_FILE;
                        errtochannel15(0);
                    }
                    break;
                }
            default:
                {
                    if (mode=='w') {

                        int f;

                        if (overwrite) f=open(s, O_CREAT|O_WRONLY, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
                        else f=open(s, O_CREAT|O_EXCL|O_WRONLY, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);

                        files[channel]=fopen(s,"wb");
                        if (f<0) errtochannel15(1); else {
                            status=OPEN_WONLY;
                            files[channel]=fdopen(f,"wb");
                            channelmode[channel]=CM_FILE;
                            errtochannel15(0);
                        }
                    } else {
                        files[channel]=fopen(s,"rb+");
                        if (files[channel]) {
                            status=OPEN_RONLY;
                            channelmode[channel]=CM_FILE;
                            errtochannel15(0);
                        } else errtochannel15(1);
                    }
                    break;
                }
            }
            
        }
    }
    sendb(status);
}

void closefile(int usecrc) {
    unsigned char channel,ch;
    channel=(ch=getb()) & 0x0f;if (tout) return;
    if (usecrc) {
        unsigned char crc=crc8[0xC3];
        crc=crc8[crc ^ ch];
        crc=crc8[crc ^ getb()];if (tout) return;
	getb();if (tout) return;
        if (crc) {fprintf(lf,"CRC error\n");return;}
    } else {
	getb();if (tout) return;
    }
    sendb(0);
    fprintf(lf,"Close [%d]\n",channel);
    if (channelmode[channel]==CM_FILE) fclose(files[channel]);
    channelmode[channel]=CM_CLOSED;
}

void readfile(int usecrc) {
    unsigned char channel,ch,status=0;
    unsigned short int bytes,i,j;
    struct timeval start,end;
    unsigned long long l=0;

    channel=(ch=getb()) & 0x0f;if (tout) return;
    bytes=getb();if (tout) return;
    bytes|=getb()*256;if (tout) return;
    if (usecrc) {
        unsigned char crc=crc8[0xD2];
        crc=crc8[crc ^ ch];
        crc=crc8[crc ^ (bytes & 0xff)];
        crc=crc8[crc ^ ((bytes >> 8) & 0xff)];
        crc=crc8[crc ^ getb()];if (tout) return;
	getb();if (tout) return;
        if (crc) {fprintf(lf,"CRC error\n");return;}
    } else {
	getb();if (tout) return;
    }
    fprintf(lf,"Read [%d] %d bytes\n",channel,bytes);
    sendb(0);if (tout) return;
    if (channelmode[channel]==CM_CLOSED) {
	sendb(0);if (tout) return;
	sendb(0);if (tout) return;
	if (usecrc) {
	    unsigned char crc=crc8[crc8[0]];
	    sendb(crc);if (tout) return;
	}
	sendb(0);return;
    }
    if (channelmode[channel]==CM_ERR) {
	j=buffp[channel];
	if (bytes==(buffbytes[channel]-j)) status=0x40;
	if (bytes>buffbytes[channel]-j) {bytes=buffbytes[channel]-j;status=0x42;}
	l=bytes;
	buffp[channel]+=bytes;
    } else {
	if (channelmode[channel]==CM_FILE) {
	    unsigned long itt;
	    l=bytes=fread(buffer[channel],1,bytes?bytes:65536,files[channel]);
	    itt=ftell(files[channel]);
	    fgetc(files[channel]);
	    if (feof(files[channel])) status=0x40;
	    fseek(files[channel],itt,SEEK_SET);
	    j=0;
	} else {
	    j=buffp[channel];
	    if (bytes==(buffbytes[channel]-j)) status=0x40;
	    if (bytes>buffbytes[channel]-j) {bytes=buffbytes[channel]-j;status=0x42;}
	    l=bytes;
	    buffp[channel]+=bytes;
	}
    }
    sendb(~bytes);if (tout) return;
    sendb(~bytes >> 8);if (tout) return;
    gettimeofday(&start,NULL);
    if (bytes) {
	unsigned short int j2=j;
	for (i=0;i<bytes;i++,j++) {sendb(buffer[channel][j]);if (tout) return;}
	if (usecrc) {
	    unsigned char crc=0;
	    crc=crc8[crc ^ (unsigned char)(~bytes)];
	    crc=crc8[crc ^ (unsigned char)(~bytes >> 8)];
	    for (i=0;i<bytes;i++,j2++) {crc=crc8[crc ^ buffer[channel][j2]];}
	    sendb(crc);if (tout) return;
	}
    }else {
	unsigned short int j2=j;
	for (i=0;i<32768;i++,j++) {sendb(buffer[channel][j]);if (tout) return;}
	for (i=0;i<32768;i++,j++) {sendb(buffer[channel][j]);if (tout) return;}
	if (usecrc) {
	    unsigned char crc=0;
	    for (i=0;i<32768;i++,j2++) {crc=crc8[crc ^ buffer[channel][j2]];}
	    for (i=0;i<32768;i++,j2++) {crc=crc8[crc ^ buffer[channel][j2]];}
	    sendb(crc);if (tout) return;
	}
    }
    gettimeofday(&end,NULL);
    l=l*1000000/((end.tv_sec-start.tv_sec)*1000000+end.tv_usec-start.tv_usec);
    fprintf(lf,"Read %d bytes at %lld bytes/seconds\n",bytes,l);
    sendb(status);//fprintf(lf,"Status: %02X\n",status);
    if (channel==15 && buffbytes[15]==buffp[15]) seterror("00, OK,000,000,000,000\r");
}

void writefile(int usecrc) {
    unsigned char channel,ch;
    unsigned short int bytes,i;
    struct timeval start,end;
    unsigned long long l=0;

    channel=(ch=getb()) & 0x0f;if (tout) return;
    bytes=getb();if (tout) return;
    bytes|=getb()*256;if (tout) return;
    if (usecrc) {
        unsigned char crc=crc8[0xD7];
        crc=crc8[crc ^ ch];
        crc=crc8[crc ^ (bytes & 0xff)];
        crc=crc8[crc ^ ((bytes >> 8) & 0xff)];
        crc=crc8[crc ^ getb()];if (tout) return;
	getb();if (tout) return;
        if (crc) {sendb(2);fprintf(lf,"CRC error\n");return;}
    } else {
	getb();if (tout) return;
    }
    fprintf(lf,"Write [%d] %d bytes\n",channel,bytes);
    if (channelmode[channel]==CM_ERR) {
        unsigned char s[256],j;
        sendb(0);if (tout) return;
        j=0;
        for (i=0;i<bytes;i++) {s[j]=getb();if (tout) return;if (j<255) j++;}

	if (usecrc) {
    	    unsigned char crc=0;

	    for (i=0;i<j;i++) crc=crc8[crc ^ s[i]];
    	    crc=crc8[crc ^ getb()];if (tout) return;
	    getb();if (tout) return;
    	    if (crc) {sendb(2);fprintf(lf,"CRC error\n");return;}
	} else {
    	    getb();if (tout) return;
	}

        s[j]=0;
        if (j && s[j-1]==0x0d) s[j-1]=0;

        sendb(0);

        commandchannel(s);
    } else {
        if (channelmode[channel]!=CM_FILE) {fprintf(lf,"Not writeable.\n");sendb(2);return;}
        sendb(0);if (tout) return;

        gettimeofday(&start,NULL);
        for (i=0;i<bytes;i++) {buffer[channel][i]=getb();if (tout) return;}
        gettimeofday(&end,NULL);
	
	if (usecrc) {
    	    unsigned char crc=0;

	    for (i=0;i<bytes;i++) crc=crc8[crc ^ buffer[channel][i]];
    	    crc=crc8[crc ^ getb()];if (tout) return;
	    getb();if (tout) return;
    	    if (crc) {sendb(2);fprintf(lf,"CRC error\n");return;}
	} else {
    	    getb();if (tout) return;
	}
	
        if (fwrite(buffer[channel],1,bytes,files[channel])==bytes) sendb(0); else sendb(2);
        l=bytes;
        l=l*1000000/((end.tv_sec-start.tv_sec)*1000000+end.tv_usec-start.tv_usec);
        fprintf(lf,"Wrote %d bytes at %lld bytes/seconds\n",bytes,l);

    }
}

const char *argp_program_bug_address="<soci@c64.rulez.org>";
static char doc[]="IDEDOS 0.9x PCLink fileserver";

static struct argp_option options[]={
    {"user",		'u',	"USER",		0,  "User under we run (nobody)"},
    {"group",		'g',	"GROUP",	0,  "Group under we run (nogroup)"},
    {"root",		'r',	"DIRECTORY",	0,  "Root directory (.)"},
    {"log",		'l',	"FILE",		0,  "Logfile (stdout)"},
    {"nice",		'n',	"ADJUST",	0,  "Adjust nice level (19)"},
    {"hog",		'h',	0,		0,  "CPU hog (off)"},
    {"background",	'b',	0, 		0,  "Fork into background"},
#ifdef PARPORT
    {"device",		'd',	"PARPORT",	0,  "Parport device"},
#endif
    { 0 }
};

struct arguments
{
    int background;
    int priority;
    char *user;
    char *group;
    char *root;
    char *log;
#ifdef PARPORT
    char *parport;
#endif
    int hog;
};

static error_t parse_opt (int key,char *arg,struct argp_state *state)
{
    struct arguments *arguments=state->input;

    switch (key)
    {
    case 'b':arguments->background=1;break;
    case 'h':arguments->hog=1;break;
    case 'u':arguments->user=arg;break;
    case 'g':arguments->group=arg;break;
    case 'l':arguments->log=arg;break;
    case 'r':arguments->root=arg;break;
#ifdef PARPORT
    case 'd':arguments->parport=arg;break;
#endif
    case 'n':arguments->priority=strtol(arg,NULL,0);printf("%s\n",arg);break;
    case ARGP_KEY_ARG:argp_usage(state);break;
    case ARGP_KEY_END:break;
    default:return ARGP_ERR_UNKNOWN;
    }
    return 0;
}

static struct argp argp={options,parse_opt,NULL,doc};

int vtime=1;

void init(int argc,char *argv[])
{
    struct passwd *user2;
    struct group *group2;
    struct arguments arguments;
    arguments.background=0;
    arguments.user= "nobody";
    arguments.group= "nogroup";
    arguments.root= ".";
    arguments.log= "/dev/stdout";
#ifdef PARPORT
    arguments.parport= "/dev/parport0";
#endif
    arguments.priority=19;
    arguments.hog=0;
    argp_parse(&argp, argc, argv, 0, 0, &arguments);

#ifdef PARPORT
    parportfd=open(arguments.parport, O_RDWR);
    if (parportfd == -1) err(1,"Opening parport device");
    if (ioctl(parportfd, PPCLAIM)) {
	close(parportfd);
	err(1,"Cannot access parport device");
    }
    {
	int mode=IEEE1284_MODE_BYTE;
	if (ioctl(parportfd, PPSETMODE, &mode)) {
	    close(parportfd);
	    err(1,"Cannot set byte mode on parport device");
	}
	
	mode=0;
	if (ioctl(parportfd, PPDATADIR, &mode)) {
	    close(parportfd);
	    err(1,"Cannot set direction on parport device");
	}
    }
#else
    if (ioperm(IOPORT,3,1)) err(1,"Allocating IO ports");
#endif

    if (!(user2=getpwnam(arguments.user))) errx(1,"User %s does not exists.",arguments.user);
    if (!(group2=getgrnam(arguments.group))) errx(1,"Group %s does not exists.",arguments.group);
    if (!(lf=fopen(arguments.log,"wt"))) err(1,"Opening logfile '%s'",arguments.log);
    if (chdir(arguments.root) || chroot(arguments.root)) err(1,"Changing root dir to '%s'",arguments.root);
    if (setgid(group2->gr_gid) || setuid(user2->pw_uid)) errx(1,"Could not drop privileges.");
    if (arguments.background) if (fork()) errx(0,"Forking into background.");
    nice(arguments.priority);
    if (arguments.hog) vtime=0;
    fclose(stdin);
    fclose(stderr);
    fclose(stdout);
}

int main(int argc,char *argv[]) {
    unsigned char b;

    init(argc,argv);
    fprintf(lf,"%s\n",argp_program_version);
    signal(SIGALRM,timeout);
    signal(SIGTERM,terminate);
    for (b=0;b<16;b++) channelmode[b]=CM_CLOSED;
    seterror("73, IDESERV 0.16 PCLINK,000,000,000,000\r");
start:
    fprintf(lf,"ready.\n");
start2:
    alarm(0);
#ifdef PC64
#ifdef PARPORT
    for (;;) {
	unsigned char b;
	ioctl(parportfd, PPRSTATUS, &b);
	if (b>=0x80) break;
	if (vtime) usleep(100000);
    }
#else
    while (inb(STATPORT)<0x80) if (vtime) usleep(100000);
#endif
    tout=0;alarm(1);
#else
    out_b(CLKLO+DATAHI+ATNHI);
    wdatalo() if (vtime) usleep(100000);
    out_b(CLKHI+DATAHI+ATNHI);
    tout=0;alarm(1);
    wdatahi() {if (vtime) usleep(10000);if (tout) goto start;} //set clklo, wait atnlo
#endif

    b=getb();if (tout) goto start;
    alarm(0);
    switch (b)
    {
//    case 'X':return 0;
    case 0x00:goto start2;
    case 'O':openfile(0);break;
    case 0xCF:openfile(1);break;
    case 'R':readfile(0);break;
    case 0xD2:readfile(1);break;
    case 'W':writefile(0);break;
    case 0xD7:writefile(1);break;
    case 'C':closefile(0);break;
    case 0xC3:closefile(1);break;
    }
    goto start;
}
